/*
 * ARCload (c) 2005 Stanislaw Skowronek
 */

#include <arclib/stdlib.h>
#include <arclib/stdio.h>
#include <arclib/arc.h>

#include "block.h"

INT bopen(BDEV *dev, CHAR *path)
{
	FILEINFORMATION info;
	if(ArcOpen(path, OpenReadOnly, &(dev->id)) != ESUCCESS)
		return -1;

	dev->pos = 0;
	dev->state = BDEV_STATE_READ;
	ArcGetFileInformation(dev->id, &info);
	dev->size = info.EndingAddress.LowPart;

	return 0;
}

VOID bseek(BDEV *dev, ULONG pos)
{
	LARGEINTEGER li;
	if(dev->state == BDEV_STATE_CLOSED)
		return;

	li.HighPart = 0;
	li.LowPart = pos;
	ArcSeek(dev->id, &li, SeekAbsolute);

	dev->pos = pos;
}

INT bread(BDEV *dev, ULONG cnt, VOID *buf)
{
	ULONG n = cnt, c, p = 0;
	if(dev->state==BDEV_STATE_CLOSED)
		return -1;

	while(n > 0) {
		if(ArcRead(dev->id, (buf + p), n, &c) != ESUCCESS)
			return -1;

		if(!c)
			return p;

		p += c;
		n -= c;
	}

	return p;
}

void bclose(BDEV *dev)
{
	ArcClose(dev->id);
	dev->state = BDEV_STATE_CLOSED;
}
